/*
 * 
 * Copyright (c) 2000 JAVIR, Ltd. All Rights Reserved.
 * 
 * 
 * JAVIR MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. JAVIR SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */
package com.javir.SkipList;

import java.awt.*;
import java.applet.*;


public class SkipList_PerformanceTest extends Applet
{
	boolean ConsolMode = true;
	int		CurrentLine = 0;
	final int MaxTexLines = 40;
	String Text[] = null;
	
	
	public static void main(String args[]){
	SkipList_PerformanceTest test = new SkipList_PerformanceTest();
		test.StartTest(100000);
		//test.StartTest(1000000);
	return;}
	//--------------------------------------------------------
	public void start(){
		Text = new String[MaxTexLines];
		ConsolMode = false;
		StartTest(100000);
		//StartTest(1000000);
	return;}
	//--------------------------------------------------------

	public void StartTest(int N){
	SkipListNode_Test nodes[] = new SkipListNode_Test[N];
	SkipList List = new SkipList();
	Print("Test started");
	//--------------------------------------------------------
	// Creating
	for(int i=0;i<N;i++){
		nodes[i] = new SkipListNode_Test();
	}
	Print(N+" nodes created ");
	//--------------------------------------------------------
	// Inserting into sorted list
	long start = System.currentTimeMillis();
	for(int i=0;i<N;i++){
		List.Insert(nodes[i]);
	}
	Print("Insert        :"+(System.currentTimeMillis()-start)+" ms");
	//List.CheckOut();
	//List.PrintOut();
	//if (start>0) return;
	//--------------------------------------------------------
	// Trying to find nodes in sorted list
	start = System.currentTimeMillis();
	for(int i=0;i<N;i++){
		SkipListNode node = (SkipListNode)List.Find(nodes[i]);
		// unrem next lines to check Find function
		//if (!node.IsEqualTo(nodes[i],0)){
		//		Print("Error : node not found");}
	}
	Print("Find node     :"+(System.currentTimeMillis()-start)+" ms");
	//--------------------------------------------------------
	// Trying to find value in sorted list
	start = System.currentTimeMillis();
	for(int i=0;i<N;i++){
		//SkipListNode node = List.Find((int)(Math.random()*1000000));
		SkipListNode node = (SkipListNode)List.Find(nodes[i].RandomValue);
		// unrem next lines to check Find function
		//if (!node.IsEqualTo(nodes[i],0)){
		//		Print("Error : node not found");}
	}
	Print("Find value    :"+(System.currentTimeMillis()-start)+" ms");
	//--------------------------------------------------------
	// Removing nodes randomly
	start = System.currentTimeMillis();
	for(int i=0;i<N;i++){
			List.Remove(nodes[i]);
	}
	Print("Remove        :"+(System.currentTimeMillis()-start)+" ms");
	//--------------------------------------------------------
	for(int i=0;i<N;i++){
			nodes[i] = null;
	}
	List = null;
	nodes = null;
	//--------------------------------------------------------
	Print("Test finished");
	return;}
	
	//--------------------------------------------------------
	public void Print(String string)
	{
	if (string==null) return;
	System.out.println(string);
	if (ConsolMode) return;
	showStatus(string);
	CurrentLine = (CurrentLine+1)%MaxTexLines;
	Text[CurrentLine] = new String(string);
	repaint();
	
	}
	//--------------------------------------------------------
	public void paint(Graphics gr)
	{
	gr.setFont(new Font("Monospaced",Font.PLAIN,12));
	gr.setColor(Color.black);
	for (int i=0;i<MaxTexLines;i++)
			if (Text[i]!=null)
					gr.drawString(Text[i],0,i*14);
	}
	//--------------------------------------------------------

	
}
